## scribus 1.5.5+dfsg

=== CMakeLists.txt ===
##############################################################################################################
########## CMake Setup                                                                              ##########

#Set our CMake minimum version
#Require 2.8.9 for Qt5 and CMAKE_POSITION_INDEPENDENT_CODE property
#Require 3.1.0 for Qt 5.7 C++ 11 easy support
#Require 3.2.0 for add_custom_target with byproducts
cmake_minimum_required(VERSION 3.2.0 FATAL_ERROR)


# Configure CCache if available and wanted
if (WANT_CCACHE)
	find_program(CCACHE_FOUND ccache)
	if(CCACHE_FOUND)
		message(STATUS "Enabling ccache")
		set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ccache)
		set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK ccache)
	endif()
endif()

#Pretty colors
set(CMAKE_COLOR_MAKEFILE ON)
#Don't force verbose
set(CMAKE_VERBOSE_MAKEFILE OFF)
#Include current dir
set(CMAKE_INCLUDE_CURRENT_DIR ON)
#Don't allow in source builds
#set(CMAKE_DISABLE_SOURCE_CHANGES ON)
#set(CMAKE_DISABLE_IN_SOURCE_BUILD ON)


#RPATH setup - more below too
if (WANT_NORPATH OR WANT_DISTROBUILD)
	set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
else()
	set(CMAKE_BUILD_WITH_INSTALL_RPATH TRUE)
endif()
set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
set(CMAKE_SKIP_RULE_DEPENDENCY TRUE)
set(CMAKE_SKIP_BUILD_RPATH TRUE)

include(CheckIncludeFile)
include(CheckCCompilerFlag)
include(CheckCXXCompilerFlag)
include(CheckTypeSize)
include(TestBigEndian)
include(GNUInstallDirs)
#include(FeatureSummary)

#enable_testing()

#Set the custom CMake module directory where our include/lib finders are
set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/modules")

##############################################################################################################
########## toplevel compiler flags                                                                  ##########
message(STATUS "Shared Library Flags: ${CMAKE_SHARED_LIBRARY_C_FLAGS}")

#Project Setup
project(scribus)
#Set our version values
#Final version is ${VERSION} = ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}.${VERSION_SUFFIX}
#where VERSION_SUFFIX is of the form "", "svn" or "Nsvn" (N being the minor patch level)
set (VERSION_MAJOR "1")
set (VERSION_MINOR "5")
set (VERSION_PATCH "5")
set (VERSION_SUFFIX "")
set (VERSION ${VERSION_MAJOR})
if (VERSION_MINOR GREATER -1)
	set (VERSION ${VERSION}.${VERSION_MINOR})
endif()
if (VERSION_PATCH GREATER -1)
	set (VERSION ${VERSION}.${VERSION_PATCH})
endif()
if (VERSION_SUFFIX)
	set (VERSION ${VERSION}.${VERSION_SUFFIX})
endif()
message(STATUS "Scribus ${VERSION} will be built and installed into ${CMAKE_INSTALL_PREFIX}")

#Set the permissions to be used when installing plugins
set(PLUGIN_PERMISSIONS WORLD_EXECUTE GROUP_EXECUTE OWNER_EXECUTE WORLD_READ GROUP_READ OWNER_READ OWNER_WRITE)

#Our main directory is scribus
set(MAIN_DIR_NAME "scribus")

##############################################################################################################
########## check for the CPU we build for                                                           ##########

execute_process(
	COMMAND ${CMAKE_C_COMPILER} -dumpmachine
	OUTPUT_VARIABLE MACHINE
	OUTPUT_STRIP_TRAILING_WHITESPACE
)

## Find out what machine/cpu we are running on
message(STATUS  "Machine: ${MACHINE}, void pointer size: ${CMAKE_SIZEOF_VOID_P}")
string(REGEX MATCH "(i[0-9]86-*)|(athlon-*)|(pentium-*)" _machine_x86 "${MACHINE}")
if (_machine_x86)
	message(STATUS "Found target X86")
	set(ARCH_X86 ON)
endif()

string(REGEX MATCH "(x86_64-*)|(X86_64-*)|(AMD64-*)|(amd64-*)" _machine_x86_64 "${MACHINE}")
if (_machine_x86_64)
	message(STATUS "Found target X86_64")
	set(ARCH_X86_64 ON)
endif()

string(REGEX MATCH "(sparc64-*)|(SPARC64-*)" _machine_sparc_64 "${MACHINE}")
if (_machine_sparc_64)
	message(STATUS "Found target SPARC 64")
	set(ARCH_SPARC_64 ON)
endif()

string(REGEX MATCH "(mips64-*)|(MIPS64-*)" _machine_mips_64 "${MACHINE}")
if (_machine_mips_64)
	message(STATUS "Found target MIPS 64")
	set(ARCH_MIPS_64 ON)
endif()

string(REGEX MATCH "(ppc-*)|(powerpc-*)" _machine_ppc "${MACHINE}")
if (_machine_ppc)
	message(STATUS "Found target PPC")
	set(ARCH_PPC ON)
endif()

string(REGEX MATCH "(ppc64-*)|(PPC64-*)|(powerpc64-*)" _machine_ppc_64 "${MACHINE}")
if (_machine_ppc_64)
	message(STATUS "Found target PPC64")
	set(ARCH_PPC_64 ON)
endif()

string(REGEX MATCH "(sparc-*)" _machine_sparc "${MACHINE}")
if (_machine_sparc)
	message(STATUS "Found target Sparc")
	set(ARCH_SPARC ON)
endif()

string(REGEX MATCH "(sparcv9-*)" _machine_sparcv9 "${MACHINE}")
if (_machine_sparcv9)
	message(STATUS "Found target Sparc v9")
	set(ARCH_SPARCV9 ON)
endif()

string(REGEX MATCH "(sparc64-*)" _machine_sparc64 "${MACHINE}")
if (_machine_sparc64)
	message(STATUS "Found target Sparc64")
	set(ARCH_SPARC64 ON)
	set(ARCH64BIT ON)
endif()

string(REGEX MATCH "(hppa*)" _machine_hppa "${MACHINE}")
if (_machine_hppa)
	message(STATUS "Found target Hppa")
	set(ARCH_HPPA ON)
endif()

# We need to pass -fPIC to lib2geom on amd64, mips, mipsel, and hppa. See:
# http://www.gentoo.org/proj/en/base/amd64/howtos/index.xml?part=1&chap=3 and
# http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=559133

set(CMAKE_POSITION_INDEPENDENT_CODE ON)

## Do our Apple OSX version setup
if ((APPLE) AND (CMAKE_SIZEOF_VOID_P EQUAL 8) AND (ARCH_X86 OR ARCH_X86_64))
	string(REGEX REPLACE ".*-darwin([0-9]+).*" "\\1" _apple_ver "${MACHINE}")
	if (_apple_ver EQUAL "19")
		message(STATUS "Found macOS Catalina Target: Apple, 64 bit, X86")
		set(APPLE_10_15_X ON CACHE BOOL "Found macOS Catalina Target: Apple, 64 bit, X86")
	endif()
	if (_apple_ver EQUAL "18")
		message(STATUS "Found macOS Mojave Target: Apple, 64 bit, X86")
		set(APPLE_10_14_X ON CACHE BOOL "Found macOS Mojave Target: Apple, 64 bit, X86")
	endif()
	if (_apple_ver EQUAL "17")
		message(STATUS "Found macOS High Sierra Target: Apple, 64 bit, X86")
		set(APPLE_10_13_X ON CACHE BOOL "Found macOS High Sierra Target: Apple, 64 bit, X86")
	endif()
	if (_apple_ver EQUAL "16")
	    message(STATUS "Found macOS Sierra Target: Apple, 64 bit, X86")
		set(APPLE_10_12_X ON CACHE BOOL "Found macOS Sierra Target: Apple, 64 bit, X86")
	endif()
	if (_apple_ver EQUAL "15")
		message(STATUS "Found OSX El Capitan Target: Apple, 64 bit, X86")
		set(APPLE_10_11_X ON CACHE BOOL "Found OSX El Capitan Target: Apple, 64 bit, X86")
	endif()
	if (_apple_ver EQUAL "14")
		message(STATUS "Found OSX Yosemite Target: Apple, 64 bit, X86")
		set(APPLE_10_10_X ON CACHE BOOL "Found OSX Yosemite Target: Apple, 64 bit, X86")
	endif()
	if (_apple_ver EQUAL "13")
		message(STATUS "Found OSX Mavericks Target: Apple, 64 bit, X86")
		set(APPLE_10_9_X ON CACHE BOOL "Found OSX Mavericks Target: Apple, 64 bit, X86")
	endif()
	if (_apple_ver EQUAL "12")
		message(STATUS "Found OSX Mountain Lion Target: Apple, 64 bit, X86")
		set(APPLE_10_8_X ON CACHE BOOL "Found OSX Mountain Lion Target: Apple, 64 bit, X86")
	endif()
	if (_apple_ver EQUAL "11")
		message(STATUS "Found OSX Lion Target: Apple, 64 bit, X86")
		set(APPLE_10_7_X ON CACHE BOOL "Found OSX Lion Target: Apple, 64 bit, X86")
	endif()
	if (_apple_ver EQUAL "10")
		message(STATUS "Found OSX Snow Leopard Target: Apple, 64 bit, X86")
		set(APPLE_10_6_X ON CACHE BOOL "Found OSX Snow Leopard Target: Apple, 64 bit, X86")
	endif()
	if (_apple_ver EQUAL "9")
		message(STATUS "Found OSX Leopard Target: Apple, 32 bit, X86")
		set(APPLE_10_5_X ON CACHE BOOL "Found OSX Leopard Target: Apple, 32 bit, X86")
	endif()
	unset(ARCH_X86)
endif()


#convert any 64 bit build into generic 64 tag for below
if (ARCH_X86_64 OR ARCH_SPARC_64 OR ARCH_MIPS_64 OR ARCH_PPC_64)
	set(ARCH64BIT ON)
endif()

message(STATUS "Building for target ${MACHINE}")

##############################################################################################################
########## Relocatability                                                                           ##########

if (APPLEBUNDLE OR WIN32)
	if (WANT_RELOCATABLE)
		message(STATUS "Ignoring relocatable option on Win32 or OSX when building bundle")
		set(WANT_RELOCATABLE OFF)
	endif()
endif()

if (WANT_RELOCATABLE)
	message(STATUS "Enabling relocatable binaries")
	set(WANT_RELOCATABLE ON CACHE BOOL "Enable relocatable binaries")
	add_definitions(-DWANT_RELOCATABLE)
endif()

##############################################################################################################
########## Versioning Setup                                                                         ##########

#On Apple, we ignore the versioning tag so all items are "scribus" not "scribus-version"
if (NOT BUILD_OSX_BUNDLE)
	set(BUILD_OSX_BUNDLE ${APPLE} CACHE BOOL "Building MacOS X Bundle")
endif()

#Simplify future conditionals for Apple
if (APPLE AND BUILD_OSX_BUNDLE)
	set(APPLEBUNDLE ON CACHE BOOL "Building Apple Bundle")
endif()

#Announce we cached a version request before, overridden below for OSX
if(TAG_VERSION)
	if (NOT APPLEBUNDLE)
		message(STATUS "Previously selected version tag: ${TAG_VERSION}")
	endif()
	set(WANT_VERSIONING ON)
	set(CACHED_VERSIONING ON)
endif()

#Remove version tags on OSX so our bundle is Scribus.app
if (APPLEBUNDLE OR WIN32)
	if (WANT_VERSIONING OR CACHED_VERSIONING)
		message(STATUS "Ignoring version tag on Win32 or OSX when building bundle")
		set(WANT_VERSIONING OFF)
		set(CACHED_VERSIONING OFF)
	endif()
endif()

#Store our version string if required
if (WANT_VERSIONING AND NOT CACHED_VERSIONING)
	if (NOT CUSTOM_VERSIONTAG)
		set(TAG_VERSION "-${VERSION}" CACHE STRING "Version string")
	else()
		set(TAG_VERSION ${CUSTOM_VERSIONTAG} CACHE STRING "Version string")
	endif()
endif()

##############################################################################################################
########## Install/Directory Setup                                                                  ##########

if (APPLEBUNDLE)
	set (APPLE_APP_DIR "${CMAKE_INSTALL_PREFIX}")
	if ("${CMAKE_INSTALL_PREFIX}" MATCHES "[.]app/Contents/?$")
		# all ok
	else()
		if ("${CMAKE_INSTALL_PREFIX}" MATCHES "[.]app/?$")
			# add "/Contents" subpath
			set(CMAKE_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}/Contents")
		else()
			# no bundle name spcified, use appname and version
			set(CMAKE_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}/Scribus${VERSION}.app/Contents")
		endif()
	endif()
	message(STATUS "APPLEBUNDLE install prefix: ${APPLE_APP_DIR}")
endif()


#Setup all the directories we will use
#cmake_policy(SET CMP0005 OLD)
#SHARE
if(WANT_VERSIONING)
	set(SHAREDIR "${CMAKE_INSTALL_DATAROOTDIR}/${MAIN_DIR_NAME}${TAG_VERSION}/")
else()
	set(SHAREDIR "${CMAKE_INSTALL_DATAROOTDIR}/${MAIN_DIR_NAME}/")
endif()

if(IS_ABSOLUTE ${SHAREDIR} AND WANT_RELOCATABLE)
	message(FATAL_ERROR "ERROR: SHAREDIR must be relative when using WANT_RELOCATABLE option")
elseif(NOT IS_ABSOLUTE ${SHAREDIR} AND NOT WANT_RELOCATABLE)
	add_definitions(-DSHAREDIR="${CMAKE_INSTALL_PREFIX}/${SHAREDIR}")
else()
	add_definitions(-DSHAREDIR="${SHAREDIR}")
endif()

#SHARE - use the default on Apple as TAG_VERSION is empty
if(WIN32 OR OS2)
	set(DOCDIR "${CMAKE_INSTALL_DATAROOTDIR}/doc/")
elseif(TAG_VERSION OR BUILD_OSX_BUNDLE)
	set(DOCDIR "${CMAKE_INSTALL_DATAROOTDIR}/doc/${MAIN_DIR_NAME}${TAG_VERSION}/")
elseif(NOT WANT_VERSIONING)
	set(DOCDIR "${CMAKE_INSTALL_DATAROOTDIR}/doc/${MAIN_DIR_NAME}/")
else()
	set(DOCDIR "${CMAKE_INSTALL_DATAROOTDIR}/doc/${MAIN_DIR_NAME}-${VERSION}/")
endif()

if(IS_ABSOLUTE ${DOCDIR} AND WANT_RELOCATABLE)
	message(FATAL_ERROR "ERROR: DOCDIR must be relative when using WANT_RELOCATABLE option")
elseif(NOT IS_ABSOLUTE ${DOCDIR} AND NOT WANT_RELOCATABLE)
	add_definitions(-DDOCDIR="${CMAKE_INSTALL_PREFIX}/${DOCDIR}")
else()
	add_definitions(-DDOCDIR="${DOCDIR}")
endif()

#ICONS
if(WIN32)
	set(ICONDIR "${CMAKE_INSTALL_DATAROOTDIR}/icons/")
else()
	set(ICONDIR "${CMAKE_INSTALL_DATAROOTDIR}/${MAIN_DIR_NAME}${TAG_VERSION}/icons/")
endif()

if(IS_ABSOLUTE ${ICONDIR} AND WANT_RELOCATABLE)

=== scribus/fonts/CMakeLists.txt ===
include_directories(
${CMAKE_SOURCE_DIR}
${CMAKE_SOURCE_DIR}/scribus
${FREETYPE_INCLUDE_DIRS}
${HARFBUZZ_INCLUDE_DIRS}
)

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CMAKE_CXX_FLAGS_FPIC}")

set(SCRIBUS_FONTS_LIB_SOURCES
  cff.cpp
  fontfeatures.cpp
  ftface.cpp
  scface.cpp
  scface_ps.cpp
  scface_ttf.cpp
  scfontmetrics.cpp
  sfnt.cpp
)
set(SCRIBUS_FONTS_LIB "scribus_fonts_lib")
add_library(${SCRIBUS_FONTS_LIB} STATIC ${SCRIBUS_FONTS_LIB_SOURCES})
# This is a convenience library that for linkage purposes is part of Scribus's
# main API.
set_target_properties(${SCRIBUS_FONTS_LIB}
  PROPERTIES
  COMPILE_FLAGS -DCOMPILE_SCRIBUS_MAIN_APP
  )

=== scribus/text/CMakeLists.txt ===
include_directories(
	${CMAKE_SOURCE_DIR}
	${CMAKE_SOURCE_DIR}/scribus
	${FREETYPE_INCLUDE_DIRS}
	${CAIRO_INCLUDE_DIRS}
	${HARFBUZZ_INCLUDE_DIRS}
	${ICU_INCLUDE_DIRS}
)

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CMAKE_CXX_FLAGS_FPIC}")

set(SCRIBUS_TEXT_MOC_CLASSES
	storytext.h
	boxes.h
)

set(SCRIBUS_TEXT_LIB_SOURCES
	boxes.cpp
	frect.cpp
	fsize.cpp
	glyphcluster.cpp
	index.cpp
	screenpainter.cpp
	scrptrun.cpp
	sctext_shared.cpp
	shapedtext.cpp
	shapedtextcache.cpp
	shapedtextfeed.cpp
	specialchars.cpp
	storytext.cpp
	textlayout.cpp
	textlayoutpainter.cpp
	textshaper.cpp
	textcontext.cpp
)

QT5_WRAP_CPP(SCRIBUS_TEXT_MOC_SOURCES ${SCRIBUS_TEXT_MOC_CLASSES})

set(SCRIBUS_TEXT_LIB "scribus_text_lib")
add_library(${SCRIBUS_TEXT_LIB} STATIC ${SCRIBUS_TEXT_LIB_SOURCES} ${SCRIBUS_TEXT_MOC_SOURCES})
# This is a convenience library that for linkage purposes is part of Scribus's
# main API.
set_target_properties(${SCRIBUS_TEXT_LIB}
	PROPERTIES
	COMPILE_FLAGS -DCOMPILE_SCRIBUS_MAIN_APP
)

=== scribus/third_party/CMakeLists.txt ===
if(HAVE_OSG)
  add_subdirectory(prc)
endif ()

if(HAVE_BOOST)
  add_subdirectory(lib2geom)
endif()

add_subdirectory(wpg)
add_subdirectory(pgf)
add_subdirectory(rtf-qt)
add_subdirectory(zip)

=== resources/iconsets/artwork/CMakeLists.txt ===
INCLUDE_DIRECTORIES(
  ${CMAKE_SOURCE_DIR}
  ${CMAKE_SOURCE_DIR}/scribus
)

##################

#Install the program icon if not on Mac and not on Windows
if(NOT WIN32 AND NOT APPLE)
	SET(SYSICONDIR "${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor")
	FOREACH(res 16x16 32x32 128x128 256x256 512x512 1024x1024)
		INSTALL(FILES
			icon_${res}.png
			RENAME scribus${TAG_VERSION}.png
			DESTINATION ${SYSICONDIR}/${res}/apps/
		)
	ENDFOREACH(res)
endif()

=== scribus/plugins/barcodegenerator/CMakeLists.txt ===
include_directories(
	${CMAKE_SOURCE_DIR}
	${CMAKE_SOURCE_DIR}/scribus
)

set(BARCODEGENERATOR_PLUGIN_UI_SRC
	barcodegenerator.ui
)

set(BARCODEGENERATOR_PLUGIN_MOC_CLASSES
	barcode.h
	barcodegenerator.h
	barcodegeneratorrenderthread.h
)

set(BARCODEGENERATOR_PLUGIN_SOURCES
	barcode.cpp
	barcodegenerator.cpp
	barcodegeneratorrenderthread.cpp
)

set(SCRIBUS_BARCODEGENERATOR_PLUGIN "barcodegenerator")

QT5_WRAP_UI(BARCODEGENERATOR_PLUGIN_UI_SOURCES ${BARCODEGENERATOR_PLUGIN_UI_SRC} )
QT5_WRAP_CPP(BARCODEGENERATOR_PLUGIN_MOC_SOURCES ${BARCODEGENERATOR_PLUGIN_MOC_CLASSES})

add_library(${SCRIBUS_BARCODEGENERATOR_PLUGIN} MODULE ${BARCODEGENERATOR_PLUGIN_SOURCES} ${BARCODEGENERATOR_PLUGIN_MOC_SOURCES} ${BARCODEGENERATOR_PLUGIN_UI_SOURCES})

target_link_libraries(${SCRIBUS_BARCODEGENERATOR_PLUGIN} ${PLUGIN_LIBRARIES})

install(TARGETS ${SCRIBUS_BARCODEGENERATOR_PLUGIN}
	LIBRARY
	DESTINATION ${PLUGINDIR}
	PERMISSIONS ${PLUGIN_PERMISSIONS}
)

install(FILES barcode.ps
	DESTINATION ${SHAREDIR}/plugins
)

add_dependencies(${SCRIBUS_BARCODEGENERATOR_PLUGIN} ${EXE_NAME})

# set_target_properties(${SCRIBUS_BARCODEGENERATOR_PLUGIN} PROPERTIES VERSION "0.0.0")

=== scribus/plugins/shapes/CMakeLists.txt ===
include_directories(
	${CMAKE_SOURCE_DIR}
	${CMAKE_SOURCE_DIR}/scribus
)

set(SHAPE_PLUGIN_MOC_CLASSES
	shapepalette.h
	shapeplugin.h
)

set(SHAPE_PLUGIN_SOURCES
	shapepalette.cpp
	shapeplugin.cpp
)

set(SCRIBUS_SHAPE_PLUGIN "shapeplugin")

QT5_WRAP_CPP(SHAPE_PLUGIN_MOC_SOURCES ${SHAPE_PLUGIN_MOC_CLASSES})

add_library(${SCRIBUS_SHAPE_PLUGIN} MODULE
	${SHAPE_PLUGIN_SOURCES}
	${SHAPE_PLUGIN_MOC_SOURCES}
)

target_link_libraries(${SCRIBUS_SHAPE_PLUGIN} ${PLUGIN_LIBRARIES})

install(TARGETS ${SCRIBUS_SHAPE_PLUGIN}
	LIBRARY
	DESTINATION ${PLUGINDIR}
	PERMISSIONS ${PLUGIN_PERMISSIONS}
)

add_dependencies(${SCRIBUS_SHAPE_PLUGIN} ${EXE_NAME})

=== scribus/plugins/short-words/CMakeLists.txt ===
include_directories(
	${CMAKE_SOURCE_DIR}
	${CMAKE_SOURCE_DIR}/scribus
)

set(SHORTWORDS_PLUGIN_UI_SRC
	swdialog.ui
	prefs_shortwordsbase.ui
)

set(SHORTWORDS_PLUGIN_MOC_CLASSES
	configuration.h
	parse.h
	prefs_shortwords.h
	shortwords.h
	swdialog.h
	swsyntaxhighlighter.h
)

set(SHORTWORDS_PLUGIN_SOURCES
	configuration.cpp
	parse.cpp
	prefs_shortwords.cpp
	shortwords.cpp
	swsyntaxhighlighter.cpp
	swdialog.cpp
)

set(SCRIBUS_SHORTWORDS_PLUGIN "scribusshortwords")

QT5_WRAP_UI(SHORTWORDS_PLUGIN_UI_SOURCES ${SHORTWORDS_PLUGIN_UI_SRC} )
QT5_WRAP_CPP(SHORTWORDS_PLUGIN_MOC_SOURCES ${SHORTWORDS_PLUGIN_MOC_CLASSES})

add_library(${SCRIBUS_SHORTWORDS_PLUGIN} MODULE
	${SHORTWORDS_PLUGIN_SOURCES}
	${SHORTWORDS_PLUGIN_MOC_SOURCES}
	${SHORTWORDS_PLUGIN_UI_SOURCES}
)

target_link_libraries(${SCRIBUS_SHORTWORDS_PLUGIN} ${PLUGIN_LIBRARIES})

install(TARGETS ${SCRIBUS_SHORTWORDS_PLUGIN}
	LIBRARY
	DESTINATION ${PLUGINDIR}
	PERMISSIONS ${PLUGIN_PERMISSIONS}
)

install(FILES scribus-short-words.rc
  DESTINATION ${SHAREDIR}/plugins
)

add_dependencies(${SCRIBUS_SHORTWORDS_PLUGIN} ${EXE_NAME})

# set_target_properties(${SCRIBUS_FONTPREVIEW_PLUGIN} PROPERTIES VERSION "0.0.0")

=== scribus/third_party/lib2geom/CMakeLists.txt ===
include_directories(
${CMAKE_SOURCE_DIR}
${CMAKE_SOURCE_DIR}/scribus
)

set(2GEOM_VERSION 0.1.0)

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CMAKE_CXX_FLAGS_FPIC}")

option(2GEOM_BUILD_SHARED
  "Build lib2geom and libtoy as shared libraries."
  OFF)
set(LIB_TYPE STATIC)

set(2GEOM_SRC
svg-path.h
svg-path.cpp
ord.h
path.cpp
path.h
path-intersection.cpp
path-intersection.h
svg-elliptical-arc.h
shape.cpp
shape.h
region.cpp
region.h
crossing.h
crossing.cpp
sweep.cpp
sweep.h
poly.cpp
poly.h
poly-dk-solve.cpp
poly-dk-solve.h
poly-laguerre-solve.cpp
poly-laguerre-solve.h
quadtree.cpp
quadtree.h
matrix.cpp
matrix.h
transforms.cpp
transforms.h
point.h
point.cpp
point-l.h
coord.h
d2.h
d2-sbasis.h
d2-sbasis.cpp
rect.h
piecewise.h
piecewise.cpp
sbasis.cpp
sbasis.h
sbasis-2d.h
sbasis-2d.cpp
sbasis-geometric.cpp
sbasis-geometric.h
sbasis-math.h
sbasis-math.cpp
sbasis-poly.cpp
sbasis-poly.h
sbasis-roots.cpp
sbasis-to-bezier.cpp
sbasis-to-bezier.h
bezier-to-sbasis.h
basic-intersection.h
basic-intersection.cpp
geom.cpp
geom.h
utils.h
exception.h
angle.h
bezier-utils.cpp
bezier-utils.h
choose.h
circulator.h
conjugate_gradient.cpp
conjugate_gradient.h
convex-cover.cpp
convex-cover.h
solve-bezier-one-d.cpp
solve-bezier-parametric.cpp
solver.h
sturm.h
scribushelper.h
scribushelper.cpp
)

set(SCRIBUS_2GEOM_LIB "scribus_2geom_lib")
add_library(${SCRIBUS_2GEOM_LIB} STATIC ${2GEOM_SRC})

# This is a convenience library that for linkage purposes is part of Scribus's
# main API.
set_target_properties(${SCRIBUS_2GEOM_LIB}
  PROPERTIES
  COMPILE_FLAGS -DCOMPILE_SCRIBUS_MAIN_APP
  )

=== scribus/third_party/zip/CMakeLists.txt ===
include_directories(
${CMAKE_SOURCE_DIR}
${CMAKE_SOURCE_DIR}/scribus
${ZLIB_INCLUDE_DIR}
)

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CMAKE_CXX_FLAGS_FPIC}")

set(SCRIBUS_ZIP_LIB_SOURCES
        unzip.cpp
        zip.cpp
        zipglobal.cpp
		scribus_zip.cpp
       )

set(SCRIBUS_ZIP_LIB_MOC_CLASSES
	zip_p.h
	unzip_p.h
)


QT5_WRAP_CPP(SCRIBUS_ZIP_LIB_MOC_SOURCES ${SCRIBUS_ZIP_LIB_MOC_CLASSES})

set(SCRIBUS_ZIB_LIB "scribus_zip_lib")
add_library(${SCRIBUS_ZIB_LIB} STATIC ${SCRIBUS_ZIP_LIB_SOURCES} ${SCRIBUS_ZIP_LIB_MOC_SOURCES})
set_target_properties(${SCRIBUS_ZIB_LIB}
  PROPERTIES
  COMPILE_FLAGS -DCOMPILE_SCRIBUS_MAIN_APP
  )

=== scribus/plugins/export/pixmapexport/CMakeLists.txt ===
include_directories(
	${CMAKE_SOURCE_DIR}
	${CMAKE_SOURCE_DIR}/scribus
)

set(SCRIBUS_PIXMAPEXPORT_PLUGIN_UI_SRC
	exportform.ui
)

set(SCRIBUS_PIXMAPEXPORT_PLUGIN_MOC_CLASSES
	dialog.h
	export.h
)

set(SCRIBUS_PIXMAPEXPORT_PLUGIN_SOURCES
	dialog.cpp
	export.cpp
)

set(SCRIBUS_PIXMAPEXPORT_PLUGIN "scribusexportpixmap")

QT5_WRAP_UI(SCRIBUS_PIXMAPEXPORT_PLUGIN_UI_SOURCES ${SCRIBUS_PIXMAPEXPORT_PLUGIN_UI_SRC} )
QT5_WRAP_CPP(SCRIBUS_PIXMAPEXPORT_PLUGIN_MOC_SOURCES ${SCRIBUS_PIXMAPEXPORT_PLUGIN_MOC_CLASSES})

add_library(${SCRIBUS_PIXMAPEXPORT_PLUGIN} MODULE ${SCRIBUS_PIXMAPEXPORT_PLUGIN_SOURCES} ${SCRIBUS_PIXMAPEXPORT_PLUGIN_MOC_SOURCES} ${SCRIBUS_PIXMAPEXPORT_PLUGIN_UI_SOURCES})

target_link_libraries(${SCRIBUS_PIXMAPEXPORT_PLUGIN} ${PLUGIN_LIBRARIES})

install(TARGETS ${SCRIBUS_PIXMAPEXPORT_PLUGIN}
	LIBRARY
	DESTINATION ${PLUGINDIR}
	PERMISSIONS ${PLUGIN_PERMISSIONS}
)

add_dependencies(${SCRIBUS_PIXMAPEXPORT_PLUGIN} ${EXE_NAME})

# set_target_properties(${SCRIBUS_FONTPREVIEW_PLUGIN} PROPERTIES VERSION "0.0.0")

=== scribus/plugins/export/svgexplugin/CMakeLists.txt ===
include_directories(
	${CMAKE_SOURCE_DIR}
	${CMAKE_SOURCE_DIR}/scribus
)

set(EXPORTSVG_PLUGIN_MOC_CLASSES
	svgexplugin.h
)

set(EXPORTSVG_PLUGIN_SOURCES
	svgexplugin.cpp
)

set(SCRIBUS_EXPORTSVG_PLUGIN "svgexplugin")

QT5_WRAP_CPP(EXPORTSVG_PLUGIN_MOC_SOURCES ${EXPORTSVG_PLUGIN_MOC_CLASSES})

add_library(${SCRIBUS_EXPORTSVG_PLUGIN} MODULE ${EXPORTSVG_PLUGIN_SOURCES} ${EXPORTSVG_PLUGIN_MOC_SOURCES})

target_link_libraries(${SCRIBUS_EXPORTSVG_PLUGIN} ${PLUGIN_LIBRARIES})

install(TARGETS ${SCRIBUS_EXPORTSVG_PLUGIN}
	LIBRARY
	DESTINATION ${PLUGINDIR}
	PERMISSIONS ${PLUGIN_PERMISSIONS}
)

add_dependencies(${SCRIBUS_EXPORTSVG_PLUGIN} ${EXE_NAME})

# set_target_properties(${SCRIBUS_FONTPREVIEW_PLUGIN} PROPERTIES VERSION "0.0.0")

=== debian/changelog ===
scribus (1.5.5+dfsg-4~mx19+1) mx; urgency=medium

  * Rebuild for MX Linux.
  * Add alternative B-D for libopenscenegraph-3.4-dev.
  * Disable automatic dbgsym packages.
  * Drop to debhelper 10 compat to workaround dh_dwz FTBFS with debhelper-
    compat 12, and to ease backports.

 -- Steven Pusser <stevep@mxlinux.org>  Fri, 17 Jan 2020 16:12:39 -0800

scribus (1.5.5+dfsg-4) experimental; urgency=low

  * Merge scribus-ng and its whole history into scribus, releasing as stable.
   + NEW MAJOR VERSION 1.5.5.
     - Completely rewritten text layout engine.  Closes: #737983
     - Move to Qt5.  Closes: #875180; LP: #1757865
  * Add a NEWS item regarding the version bump.
  * d/control: Drop hard-coded dependency on python.  Closes: #948430

 -- Mattia Rizzolo <mattia@debian.org>  Wed, 15 Jan 2020 21:13:07 +0100

scribus-ng (1.5.5+dfsg-3) experimental; urgency=medium

  * d/control:
    + Build-Depend on python2-dev instead of python-all, since what we are
      interested in are the header files.

 -- Mattia Rizzolo <mattia@debian.org>  Sat, 28 Dec 2019 21:04:57 +0100

scribus-ng (1.5.5+dfsg-2) experimental; urgency=medium

  * d/rules: Stop compressing the TRANSLATION file.
    Bug: https://bugs.scribus.net/view.php?id=14098
  * d/control:
    + Replace build-dependency with unversioned openscenegraph, now that it
      has been updated and it points to a Qt5 version.
    + Bump Standards-Version to 4.4.1, no changes needed.
    + Drop direct dependency on python-tk from the main binary.

 -- Mattia Rizzolo <mattia@debian.org>  Sat, 23 Nov 2019 16:49:26 +0100

scribus-ng (1.5.5+dfsg-1) experimental; urgency=medium

  * New upstream version 1.5.5+dfsg.
    https://wiki.scribus.net/canvas/1.5.5_Release
  * d/copyright: Update.
  * Drop patches applied upstream.
  * d/control:
    + Bump the debhelper compat level.
    + Bump Standards-Version to 4.4.0, no changes needed.
    + Bump the required cmake version to >= 3.12.0

 -- Mattia Rizzolo <mattia@debian.org>  Tue, 06 Aug 2019 10:32:24 +0200

scribus-ng (1.5.4+dfsg-4) experimental; urgency=medium

  [ Ondřej Nový ]
  * d/copyright: Change Format URL to correct one.
  * d/watch: Use https protocol.

  [ Mattia Rizzolo ]
  * Add patch from upstream trunk to allow finding the new hunspell.
  * Add a bunch of patches from upstream to support poppler up to 0.73.
    Closes: #919119
  * d/control: Bump Standards-Version to 4.3.0, no changes needed.
  * d/copyright: Bump the year for debian/*.

 -- Mattia Rizzolo <mattia@debian.org>  Mon, 11 Feb 2019 17:00:21 +0100

scribus-ng (1.5.4+dfsg-3) experimental; urgency=medium

  * Add patch from upstream to fix build with poppler 0.64.
    + This bumps the required poppler version to >= 0.64 to avoid backporting
      another big patch to add compat with older versions.
  * Add patch from upstream to fix build with poppler 0.69.

 -- Mattia Rizzolo <mattia@debian.org>  Mon, 05 Nov 2018 10:25:54 +0100

scribus-ng (1.5.4+dfsg-2) experimental; urgency=medium

  * d/control:
    + Bump Standards-Version to 4.2.1, no changes needed.
    + Move to openscenegraph-3.4 (from 3.2).  This way we have a qt5-only
      scribus-ng, as openscenegraph 3.2 uses qt4.
  * d/scribus-ng-data.links: tweak link so to avoid a broken symlink if
    somebody installs scribus-ng-data only.  Closes: #905416

 -- Mattia Rizzolo <mattia@debian.org>  Fri, 21 Sep 2018 09:40:05 +0200

scribus-ng (1.5.4+dfsg-1) experimental; urgency=medium

  * New upstream version 1.5.4+dfsg.
    https://wiki.scribus.net/canvas/1.5.4_Release
  * d/upstream/signing-key.asc: Refresh.
  * Remove patches applied upstream.
  * d/control:
    + Bump Standards-Version to 4.1.4, no changes needed.
    + Move Vcs-* to salsa.debian.org.
    + Use HTTPS in the Homepage field.
    + Add new build-dependencies on libqxp-dev and libzmf-dev.
  * d/rules:
    + Use dh_missing instead of the deprecated dh_install --fail-missing.
  * Bump debhelper compat level to 11:
    + Remove --parallel, now default
  * d/scribus-ng.mime: remove: if it's needed I want it upstream first.
  * d/copyright:
    + Use HTTPS in the Source field.
    + Update.

 -- Mattia Rizzolo <mattia@debian.org>  Wed, 09 May 2018 00:25:30 +0200

scribus-ng (1.5.3+dfsg-2) experimental; urgency=medium

  * d/control:
    + Add Build-Depends on libpoppler-cpp-dev.
    + Drop Recommends of scribus-ng from scribus-ng-data.
    + Bump Standards-Version to 4.1.2:
      - Change priority from extra (deprecated) to optional.
      -  Use HTTPS in d/copyright's Format field.
    + Declere that scribus-ng can be built without root: R³:no.
  * Add patch from upstream to fix FTBFS with poppler >= 0.58.

 -- Mattia Rizzolo <mattia@debian.org>  Sun, 10 Dec 2017 00:56:26 +0100

scribus-ng (1.5.3+dfsg-1) experimental; urgency=medium

  * New upstream version 1.5.3+dfsg.  Closes: #863687
    https://wiki.scribus.net/canvas/1.5.3_Release
  * d/copyright:
    + Update list of excluded files.
    + Update copyright/license information.
  * d/patches:
    + Drop patches applied upstream.
    + Refresh patches.
    + findOpenSSL: add to fix build configuration with libpodofo >= 0.9.5.
  * d/control:
    + Add new build-dependency on libharfbuzz-dev.
    + Bump Standards-Version to 4.0.0, no changes needed.
  * d/rules: don't deal with files not shipped anymore.
  * d/scirbus-ng-data.install: don't install a file not shipped anymore.
  * d/upstream/signing-key.asc:
    + Refresh plinnell's key and add the new "Scribus Team" signing key.
  * d/scribus-ng.lintian-overrides: drop now seemingly unneeded overrides.

 -- Mattia Rizzolo <mattia@debian.org>  Mon, 05 Jun 2017 21:34:24 +0200

scribus-ng (1.5.2+dfsg-4) experimental; urgency=medium

  * d/copyright: bump the year for debian/*.
  * d/patches:
    + (finally) drop qreal_double patch: scribus-ng builds fine everywhere now.
    + fix_FTBFS_BE: mark as upstreamed.
    + install-icons.patch: new patch from upstream trunk, to install the high
      resolution icons.


=== debian/control ===
Source: scribus
Section: graphics
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Mattia Rizzolo <mattia@debian.org>
Build-Depends:
 cmake (>= 3.12.0),
 debhelper (>= 10.2~),
 dh-exec,
 dh-python,
 extra-cmake-modules,
 gettext,
 libboost-python-dev,
 libcairo2-dev,
 libcdr-dev,
 libcups2-dev,
 libfreehand-dev,
 libgraphicsmagick++1-dev,
 libharfbuzz-dev,
 libhunspell-dev,
 libhyphen-dev,
 libicu-dev,
 liblcms2-dev,
 libmspub-dev,
 libopenscenegraph-dev (>= 3.4) | libopenscenegraph-3.4-dev,
 libpagemaker-dev,
 libpodofo-dev,
 libpoppler-cpp-dev,
 libpoppler-dev (>= 0.64.0),
 libpoppler-private-dev,
 libqt5opengl5-dev,
 libqt5webkit5-dev,
 libqxp-dev,
 librevenge-dev,
 libtiff-dev,
 libvisio-dev,
 libwpg-dev,
 libxml2-dev,
 libzmf-dev,
 python2-dev,
 qtbase5-dev,
 qttools5-dev,
 qttools5-dev-tools,
 zlib1g-dev,
Standards-Version: 4.4.1
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/debian/scribus
Vcs-Git: https://salsa.debian.org/debian/scribus.git
Homepage: https://www.scribus.net

Package: scribus
Architecture: any
Depends:
 ghostscript,
 scribus-data (= ${source:Version}),
 ${misc:Depends},
 ${python:Depends},
 ${shlibs:Depends},
 cups-bsd,
 fonts-dejavu,
 fonts-liberation,
 hyphen-hyphenation-patterns,
Recommends:
 icc-profiles-free,
 xfonts-scalable | gsfonts-x11,
Suggests:
 icc-profiles,
 scribus-ng-doc,
 scribus-template,
 texlive-latex-recommended,
Description: Open Source Desktop Page Layout
 Scribus is an open source desktop page layout program with the aim of
 producing commercial grade output in PDF and Postscript.
 .
 Scribus can be used for many tasks; from brochure design to newspapers,
 magazines, newsletters and posters to technical documentation.
 .
 Scribus supports professional DTP features, such as CMYK color and a
 color management system to soft proof images for high quality color printing,
 flexible PDF creation options, Encapsulated PostScript import/export and
 creation of 4 color separations, import of EPS/PS and SVG as native vector
 graphics, Unicode text including right to left scripts such as Arabic and
 Hebrew via freetype. Graphic formats which can be placed in Scribus as images
 include PDF, Encapsulated Post Script (eps), TIFF, JPEG, PNG and XPixMap(xpm),
 and any bitmap type supported by QT5.
 .
 If you need to use the render frame install the texlive-latex-recommended
 package (suggested).

Package: scribus-data
Architecture: all
Depends:
 python-tk,
 ${misc:Depends},
 ${python:Depends},
Recommends:
 fonts-dejavu,
Description: Open Source Desktop Page Layout - data files
 Scribus is an open source desktop page layout program with the aim of
 producing commercial grade output in PDF and Postscript.
 .
 Scribus can be used for many tasks; from brochure design to newspapers,
 magazines, newsletters and posters to technical documentation.
 .
 Scribus supports professional DTP features, such as CMYK color and a
 color management system to soft proof images for high quality color printing,
 flexible PDF creation options, Encapsulated PostScript import/export and
 creation of 4 color separations, import of EPS/PS and SVG as native vector
 graphics, Unicode text including right to left scripts such as Arabic and
 Hebrew via freetype. Graphic formats which can be placed in Scribus as images
 include PDF, Encapsulated Post Script (eps), TIFF, JPEG, PNG and XPixMap(xpm),
 and any bitmap type supported by QT5.
 .
 This package contains the architecture-independent files.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

CFLAGS += -D_LARGEFILE64_SOURCE=1 -D_LARGEFILE_SOURCE=1 -D_FILE_OFFSET_BITS=64
CXXFLAGS += -D_LARGEFILE64_SOURCE=1 -D_LARGEFILE_SOURCE=1 -D_FILE_OFFSET_BITS=64

t :=
p := scribus$t
export p

ifneq (,$t)
extraconf := \
	-DWANT_DEBUG:BOOL=1 \
	-DWANT_VERSIONING:BOOL=1 \
	-DCUSTOM_VERSIONTAG=$t
else
extraconf :=
endif

%:
	dh $@ --buildsystem=cmake --with python2

override_dh_auto_configure:
	dh_auto_configure -- \
	    -DWANT_HUNSPELL=1 \
	    -DWANT_GRAPHICSMAGICK:BOOL=1 \
	    -DWANT_DISTROBUILD:BOOL=1 \
	    -DWANT_NORPATH:BOOL=1 \
	    -DCMAKE_SKIP_RPATH:BOOL=1 \
	    $(extraconf)

override_dh_auto_install:
	dh_auto_install
ifneq (,$(findstring doc, $(shell grep -e '^Package: ' debian/control)))
	# move the docs somewhere else, so that I can then pick them up
	# do it only if we are building the -doc package from the same source.
	# This won't be the case for the official Debian package, as the
	# documentation is non-free and in a separate source package.
	mkdir -p $(CURDIR)/debian/tmp/doc
	mv -v $(CURDIR)/debian/tmp/usr/share/doc/$p/en \
	      $(CURDIR)/debian/tmp/usr/share/doc/$p/de \
	      $(CURDIR)/debian/tmp/usr/share/doc/$p/it \
	      $(CURDIR)/debian/tmp/doc
endif
	# remove pointless files.
	rm -v $(CURDIR)/debian/tmp/usr/share/doc/$p/ChangeLog \
	      $(CURDIR)/debian/tmp/usr/share/doc/$p/COPYING
	find $(CURDIR)/debian/tmp -type d -empty -print -delete
	# remove references to prorietary fonts and use free fonts in templates.
	# also remove references to Bitstream fonts, which are unmaintained, and
	# use DejaVu ones, instead
	# See https://bugs.debian.org/742003 and https://launchpad.net/bugs/1393349
	# https://bugs.scribus.net/view.php?id=14688
	# https://bugs.scribus.net/view.php?id=14689
	gunzip -v $(CURDIR)/debian/tmp/usr/share/$p/templates/*/*.sla.gz
	sed -i $(CURDIR)/debian/tmp/usr/share/$p/templates/*/*.sla \
		-e 's/Arial Regular/Liberation Sans Regular/g' \
		-e 's/Arial Black Regular/Liberation Sans Bold/g' \
		-e 's/FreeSans Medium/Liberation Sans Bold/g' \
		-e 's/Bitstream Vera Sans Roman/DejaVu Sans Book/g' \
		-e 's/Bitstream Vera Sans Mono Roman/DejaVu Sans Mono Book/g' \
		-e 's/Bitstream Vera Serif Roman/DejaVu Serif Book/g' \
		-e 's/Bitstream Vera Serif/DejaVu Serif/g' \
		-e 's/Bitstream Vera Sans/DejaVu Sans/g' \
		-e 's/Bitstream Vera Mono/DejaVu Mono/g'
	gzip -v -n -8 $(CURDIR)/debian/tmp/usr/share/$p/templates/*/*.sla

override_dh_missing:
	dh_missing --fail-missing

override_dh_fixperms:
	# the plugins (which are the only .so files here) needs to be +x.
	# let the scribus installer take care of them
	dh_fixperms -X .so

override_dh_python2:
	dh_python2 /usr/share/$p/samples/
	dh_python2 /usr/share/$p/scripts/

# scribus expects the {docdir}/{lang}/menu.xml being present and uncompressed,
# otherwise you'll get no docs.
override_dh_compress:
	dh_compress -X usr/share/doc/$p/de \
				-X usr/share/doc/$p/en \
				-X usr/share/doc/$p/it \
				-X usr/share/doc/$p/TRANSLATION \

override_dh_strip:
	dh_strip --no-automatic-dbgsym
